/* Author:   $Author: jan $
 * File:     $Source: /usr/usrs/jan/desktop/X_Book.boo/programs/RCS/draw.c,v $
 * Date:     $Date: 1992/09/09 00:09:51 $
 * Revision: $Revision: 1.1 $
 */

#include "copyright.h"

#include <stdio.h> 
 
#include <Xm/DrawingA.h> 
 
/*------------------------------------------------------------- 
**     Forward Declarations 
*/ 
 
void main ();            /*  main logic for application    */ 
void CreateApplication ();    /*  create main window        */ 
void display_somethingCB ();            /*  callback for quit button    */ 
 
/*------------------------------------------------------------- 
**    Global Variables 
*/ 
 
#define MAX_ARGS 20 
#define Class_name "Draw" 
 
Widget  draw_area;   /*  Drawing Area widget              */ 
Display *display;    /* the display device                */    
int     screen;      /* the screen on the display         */    
Window  draw_window; /* the drawing area widgets's window */   
GC      gc;    

    
/*------------------------------------------------------------- 
** Create a graphics context using default values, and    
** return it in the pointer gc    
*/    
GC
getGC ()
{   GC gc;    
    

    gc = XCreateGC (display, draw_window,     
                (unsigned long) 0, NULL);    
    
    XSetForeground (display, gc, (unsigned long) 1);
    XSetBackground (display, gc,(unsigned long) 0);
    return (gc);
}    
    
/*------------------------------------------------------------- 
** Write a string    
** and draw a circle   
*/    
void display_somethingCB (w, client_data, call_data)  
Widget        w;        /*  widget id        */ 
caddr_t       client_data;    /*  data from application   */ 
caddr_t       call_data;    /*  data from widget class  */ 
{
    /* the proverbial string */    
    XDrawImageString (display, draw_window, gc,    
                      10, 10, "Hello world",    
                      strlen ("Hello world"));    
    
    /* and a world (circle) to go with it */    
    XDrawArc (display, draw_window, gc,    
               30, 30,
               100, 100, 
               0, 360*64);
    XFlush (display);
}    
/*------------------------------------------------------------- 
**    main        - main logic for application 
*/ 
void main (argc,argv)  
    unsigned int    argc; 
    char         **argv; 
{ 
    Widget        app_shell;    /*  ApplicationShell    */ 
 
     /*    Initialize toolkit, open the display and create the toplevel widget. */ 
    app_shell = XtInitialize(argv[0], /* application name */    
               Class_name,     /* class name */    
               NULL,         /* options */    
               0,        /* number of options */    
               &argc, argv);    
  
    /* set up all the sub-widgets */ 
    CreateApplication(app_shell);
    XtRealizeWidget (app_shell); 

    /* Now get info about windows, etc 
    ** The XtWindow() _must_ occur after XtRealize() has
    ** created the Drawing Area's window
    */
    display = XtDisplay (draw_area);
    draw_window = XtWindow (draw_area);
    gc = getGC ();
 
    /*    Get and dispatch events. 
    */ 
    XtMainLoop (); 
} 
 
/*------------------------------------------------------------- 
**     CreateApplication    - create main window 
*/ 
void CreateApplication (parent)  
Widget        parent;        /*  parent widget    */ 
{ 
 
     Arg        args[MAX_ARGS];    /*  arg list        */ 
     register int    n;        /*  arg count        */ 
 
     /*    Create Drawing Area
     **    Make it a reasonable size
     */ 
     n = 0; 
     XtSetArg (args[n], XmNwidth, 300); n++;
     XtSetArg (args[n], XmNheight, 300); n++;
     draw_area = XmCreateDrawingArea (parent, "an_area", args, n);    
     XtAddCallback (draw_area, XmNexposeCallback, display_somethingCB);
     XtManageChild (draw_area);     
} 
